#!/bin/bash

#Pega o diretório até aqui (onde esta os arquivos), é necessário que as pastas não tenha espaços nos seus nomes
caminho=$(pwd)

#Armazena nas variáveis o caminho de cada arquivo
caminhoMidias=$caminho'/midias.sh'
caminhoGeneros=$caminho'/generos.sh'
caminhoExtatisticaTXT=$caminho'/1-estatistica.txt'

#Carrega os arquivos como se eles fossem bibliotecas
. $caminhoMidias
. $caminhoGeneros

function cria_Extatistica {
    horas_consumidas=0
    horas_aConsumir=0
    
    quantidadeFilmes=${#filmes[@]} #pega a quantidade de elementos que tem no vetor
    #Este primeiro for passa todo o vetor saltando de 13 em 13 posições começando do 0 e indo até o seu tamanho -13
    for i in $(seq 0 13 $[ $quantidadeFilmes - 13 ]);
    do
        maisDez=$[ $i + 10 ]
        maisCinco=$[ $i + 5 ]
        consumiuFilme=${filmes[$maisDez]}
        
        if [ ${#consumiuFilme} -eq 0 ]; 
        then
            horas_aConsumir=$[ $horas_aConsumir + ${filmes[$maisCinco]} ]
            
        else
            horas_consumidas=$[ $horas_consumidas + ${filmes[$maisCinco]} ]
        
        fi
        
    done
    
    quantidadeSeries=${#series[@]} #pega a quantidade de elementos que tem no vetor
    #Este primeiro for passa todo o vetor saltando de 13 em 13 posições começando do 0 e indo até o seu tamanho -13
    for i in $(seq 0 13 $[ $quantidadeSeries - 13 ]);
    do
        maisDez=$[ $i + 10 ]
        maisCinco=$[ $i + 5 ]
        consumiuSerie=${series[$maisDez]}
        
        if [ ${#consumiuSerie} -eq 0 ]; 
        then
            horas_aConsumir=$[ $horas_aConsumir + ${series[$maisCinco]} ]
            
        else
            horas_consumidas=$[ $horas_consumidas + ${series[$maisCinco]} ]
        
        fi
        
    done
    
    echo "Horas consumidas: $horas_consumidas minutos" >> $caminhoExtatisticaTXT
    echo "Horas a consumir: $horas_aConsumir minutos" >> $caminhoExtatisticaTXT
    echo >> $caminhoExtatisticaTXT
    echo "Midias por genero:" >> $caminhoExtatisticaTXT
    
    #Inicializa um vetor com os dados de cada genero mais a quantida de midias correspondente
    quantidadeGeneros=${#generos[@]}
    pos=0
    for i in $(seq 0 2 $[ $quantidadeGeneros - 2 ]);
    do
        midias_generos[$pos]=${generos[$i]}
        pos=$[ $pos + 1 ]
        midias_generos[$pos]=${generos[$i + 1]}
        pos=$[ $pos + 1 ]
        midias_generos[$pos]=0
        pos=$[ $pos + 1 ]
    done
    
    quantidadeq=${#midias_generos[@]} #pega a quantidade de elementos que tem no vetor
    for i in $(seq 0 3 $[ $quantidadeq - 3 ]);
    do
        for f in $(seq 0 13 $[ $quantidadeFilmes - 13 ]);
        do
            generoFilme=${filmes[$f + 6]}
            
            if [ "$generoFilme" == "${midias_generos[$i]}" ]; 
            then
                midias_generos[$i + 2]=$[ midias_generos[$i + 2] + 1 ]
            fi
            
        done
        
        for f in $(seq 0 13 $[ $quantidadeSeries - 13 ]);
        do
            generoSerie=${series[$f + 6]}
#            echo "$generoSerie"
            
            if [ "$generoSerie" == "${midias_generos[$i]}" ]; 
            then
                midias_generos[$i + 2]=$[ midias_generos[$i + 2] + 1 ]
            fi
            
        done
    done
	
	declare -a aux
    
    for i in $(seq 0 3 $[ $quantidadeq - 3 ]);
    do
        for j in $(seq 0 3 $[ $[$quantidadeq - $i] - 6]);
        do
            if [ ${midias_generos[$j + 2]} -lt ${midias_generos[$j + 3 + 2]} ]
            then
                aux[0]=${midias_generos[$j]}
                aux[1]=${midias_generos[$j + 1]}
                aux[2]=${midias_generos[$j + 2]}
                
                midias_generos[$j]=${midias_generos[$j + 3]}
                midias_generos[$j + 1]=${midias_generos[$j + 4]}
                midias_generos[$j + 2]=${midias_generos[$j + 5]}
                
                midias_generos[$j + 3]=${aux[0]}
                midias_generos[$j + 4]=${aux[1]}
                midias_generos[$j + 5]=${aux[2]}
            fi
        done
    done

    for i in $(seq 0 3 $[ $quantidadeq - 3 ]);
    do
        echo "    ${midias_generos[$i + 1]}: ${midias_generos[$i + 2]}" >> $caminhoExtatisticaTXT
    done
    
    #Inicializa um vetor com as series a quantidade de assistidos e a assistir de cada serie
    declare -a temporadaSerie
    
    for i in $(seq 0 13 $[ $quantidadeSeries - 13 ]);
    do
        flag=0
        quantTemporadaSerie=${#temporadaSerie[@]}
        consumiuSerie=${series[$i + 10]}
        
        if [ $quantTemporadaSerie -eq 0 ]
        then
            temporadaSerie[0]=${series[$i + 7]}
            
            if [ ${#consumiuSerie} -eq 0 ];
            then
                temporadaSerie[1]=0
                temporadaSerie[2]=1
            else
                temporadaSerie[1]=1
                temporadaSerie[2]=0
            fi
            
        else
            for j in $(seq 0 3 $[ $quantTemporadaSerie - 3 ]);
            do
                if [ "${series[$i + 7]}" == "${temporadaSerie[$j]}" ]
                then
                    flag=1
                    
                    if [ ${#consumiuSerie} -eq 0 ];
                    then
                        temporadaSerie[$j + 2]=$[ temporadaSerie[$j + 2] + 1 ]
                    else
                        temporadaSerie[$j + 1]=$[ temporadaSerie[$j + 1] + 1 ]
                    fi
                fi 
            done
            
            if [ $flag -eq 0 ]
            then
                temporadaSerie[$quantTemporadaSerie]=${series[$i + 7]}
                
                if [ ${#consumiuSerie} -eq 0 ];
                then
                    temporadaSerie[$quantTemporadaSerie + 1]=0
                    temporadaSerie[$quantTemporadaSerie + 2]=1
                else
                    temporadaSerie[$quantTemporadaSerie + 1]=1
                    temporadaSerie[$quantTemporadaSerie + 2]=0
                fi
            fi            
        fi
    done
    
    quantTemporadaSerie=${#temporadaSerie[@]}
    
    echo >> $caminhoExtatisticaTXT
    echo "Temporadas por série:" >> $caminhoExtatisticaTXT
    
    for i in $(seq 0 3 $[ $quantTemporadaSerie - 3 ]);
    do
        echo "    ${temporadaSerie[$i]}: ${temporadaSerie[$i + 1]} assistidas, ${temporadaSerie[$i + 2]} a assistir" >> $caminhoExtatisticaTXT
    done
    
    echo
}
