#!/bin/bash

#Declara filmes como sendo uma variavel global
declare -a filmes
declare -a livros
declare -a series

function imprime_Filmes {
    #esta é a maneira como iremos acessar os dados de cada filme, aqui estou simplesmente imprimindo os valor
    quantidadeDados=${#filmes[@]} #pega a quantidade de elementos que tem no vetor
    #Este primeiro for passa todo o vetor saltando de 13 em 13 posições começando do 0 e indo até o seu tamanho -13
    for i in $(seq 0 13 $[ $quantidadeDados - 13 ]);
    do
        #Este segundo for irá imprimir apenas os dados de cada filme, ele iniciará na posição de i e imprimirá e irá terminar depois de imprimir mais 12 vezes
        for j in $(seq $i 1 $[ $i + 12 ])
        do
            echo "${filmes[$j]}"
        done
        echo "---------------------------"
    done
    echo "---------------------------"
}

function imprime_Livros {
    #esta é a maneira como iremos acessar os dados de cada livro, aqui estou simplesmente imprimindo os valor
    quantidadeDados=${#livros[@]} #pega a quantidade de elementos que tem no vetor
    #Este primeiro for passa todo o vetor saltando de 13 em 13 posições começando do 0 e indo até o seu tamanho -13
    for i in $(seq 0 13 $[ $quantidadeDados - 13 ]);
    do
        #Este segundo for irá imprimir apenas os dados de cada filme, ele iniciará na posição de i e imprimirá e irá terminar depois de imprimir mais 12 vezes
        for j in $(seq $i 1 $[ $i + 12 ])
        do
            echo "${livros[$j]}"
        done
        echo "---------------------------"
    done
    echo "---------------------------"
}

function imprime_Series {
    #esta é a maneira como iremos acessar os dados de cada serie, aqui estou simplesmente imprimindo os valor
    quantidadeDados=${#series[@]} #pega a quantidade de elementos que tem no vetor
    #Este primeiro for passa todo o vetor saltando de 13 em 13 posições começando do 0 e indo até o seu tamanho -13
    for i in $(seq 0 13 $[ $quantidadeDados - 13 ]);
    do
        #Este segundo for irá imprimir apenas os dados de cada filme, ele iniciará na posição de i e imprimirá e irá terminar depois de imprimir mais 12 vezes
        for j in $(seq $i 1 $[ $i + 12 ])
        do
            echo "${series[$j]}"
        done
        echo "---------------------------"
    done
    echo "---------------------------"
}

#Como nao ha possibilidade de estruturar um objeto, esta funçao ira criar os vetores separado de filmes, livros e series.
#E como nao ha a possibilidade de retornar vetores, ele apenas ira preencher os vetores globais declarados no topo do codigo 
function criaVetores_Midias {
    posicaoLinha=0
    posicaoVetor_Filme=0
    posicaoVetor_Livro=0
    posicaoVetor_Serie=0
        
    #este while passa todo o arquivo midias.csv e para cada passada linha recebe a linha do arquivo 
    while read linha; do
	
		#echo $linha
    
        #Retorna da string tudo antes do ;
        codigo=${linha%%;*}
        #rescreve o linha deletando o que vem antes do ;
        linha=${linha#*;}
        
        nome=${linha%%;*} 
        linha=${linha#*;}
        
        tipo=${linha%%;*} 
        linha=${linha#*;}
        
        diretor=${linha%%;*} 
        linha=${linha#*;}
        
        aUtores=${linha%%;*} 
        linha=${linha#*;}
        
        tamanho=${linha%%;*} 
        linha=${linha#*;}
        
        genero=${linha%%;*} 
        linha=${linha#*;}
        
        serie=${linha%%;*} 
        linha=${linha#*;}
        
        temporada=${linha%%;*} 
        linha=${linha#*;}
        
        possui=${linha%%;*} 
        linha=${linha#*;}
        
        consumiu=${linha%%;*} 
        linha=${linha#*;}
        
        deseja=${linha%%;*} 
        linha=${linha#*;}
        
        preco=${linha%%;*} 
        linha=${linha#*;}
        
        #Ignora a primeira linha
        if [ $posicaoLinha -gt 0 ]; 
        then
            #filmes, livros e series sao vetores que terá todos os seus respectivos valores, sao vetores simples porque o shell não permite vetor de vetor e nem ponteiros.
            #Então a gente vai saber que o primeiro filme, livro ou serie terminou depois de 13 posições (quantida de dados para cada midia), o segundo mais 13 e por aí vai
            
            case $tipo in
                "F")
                    filmes[$posicaoVetor_Filme]=$codigo
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$nome
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$tipo
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$diretor
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$aUtores
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$tamanho
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$genero
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$serie
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$temporada
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$possui
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$consumiu
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$deseja
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		            
		            filmes[$posicaoVetor_Filme]=$preco
		            posicaoVetor_Filme=$[ $posicaoVetor_Filme + 1 ]
		        ;;
		        
		        "L")
                    livros[$posicaoVetor_Livro]=$codigo
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$nome
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$tipo
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$diretor
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$aUtores
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$tamanho
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$genero
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$serie
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$temporada
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$possui
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$consumiu
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$deseja
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
		            
		            livros[$posicaoVetor_Livro]=$preco
		            posicaoVetor_Livro=$[ $posicaoVetor_Livro + 1 ]
	            ;;
	            
	            "S")
                    series[$posicaoVetor_Serie]=$codigo
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$nome
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$tipo
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$diretor
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$aUtores
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$tamanho
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$genero
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$serie
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$temporada
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$possui
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$consumiu
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$deseja
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		            
		            series[$posicaoVetor_Serie]=$preco
		            posicaoVetor_Serie=$[ $posicaoVetor_Serie + 1 ]
		        ;;
		        
	            *) echo
	        esac    
	        
            
        fi
        
        posicaoLinha=$[ $posicaoLinha + 1 ]
        
    done < midias.csv
}